import type * as Runners from "@effect/cluster/Runners";
import type { Sharding } from "@effect/cluster/Sharding";
import * as ShardingConfig from "@effect/cluster/ShardingConfig";
import type * as SocketServer from "@effect/platform/SocketServer";
import type { SqlClient } from "@effect/sql/SqlClient";
import type { SqlError } from "@effect/sql/SqlError";
import type { ConfigError } from "effect/ConfigError";
import * as Layer from "effect/Layer";
/**
 * @since 1.0.0
 * @category Layers
 */
export declare const layerSocketServer: Layer.Layer<SocketServer.SocketServer, SocketServer.SocketServerError, ShardingConfig.ShardingConfig>;
/**
 * @since 1.0.0
 * @category Layers
 */
export declare const layer: <const ClientOnly extends boolean = false, const Storage extends "noop" | "sql" = "noop">(options?: {
    readonly serialization?: "msgpack" | "ndjson" | undefined;
    readonly clientOnly?: ClientOnly | undefined;
    readonly storage?: Storage | undefined;
    readonly shardingConfig?: Partial<ShardingConfig.ShardingConfig["Type"]> | undefined;
}) => ClientOnly extends true ? Layer.Layer<Sharding | Runners.Runners, ConfigError, Storage extends "sql" ? SqlClient : never> : Layer.Layer<Sharding | Runners.Runners, SocketServer.SocketServerError | ConfigError | (Storage extends "sql" ? SqlError : never), Storage extends "sql" ? SqlClient : never>;
//# sourceMappingURL=NodeClusterRunnerSocket.d.ts.map