import * as ShardingConfig from "@effect/cluster/ShardingConfig";
import * as ShardManager from "@effect/cluster/ShardManager";
import type * as SocketServer from "@effect/platform/SocketServer";
import type { SqlClient } from "@effect/sql/SqlClient";
import type { SqlError } from "@effect/sql/SqlError";
import type { ConfigError } from "effect/ConfigError";
import * as Layer from "effect/Layer";
/**
 * @since 1.0.0
 * @category Layers
 */
export declare const layerSocketServer: Layer.Layer<SocketServer.SocketServer, SocketServer.SocketServerError, ShardingConfig.ShardingConfig>;
/**
 * @since 1.0.0
 * @category Layers
 */
export declare const layer: <const Storage extends "sql" | "noop" = "noop">(options?: {
    readonly serialization?: "msgpack" | "ndjson" | undefined;
    readonly shardingConfig?: Partial<ShardingConfig.ShardingConfig["Type"]> | undefined;
    readonly storage?: Storage | undefined;
}) => Layer.Layer<ShardManager.ShardManager, SocketServer.SocketServerError | ConfigError | (Storage extends "sql" ? SqlError : never), Storage extends "sql" ? SqlClient : never>;
//# sourceMappingURL=NodeClusterShardManagerSocket.d.ts.map